#<profile4xi profile = "31"/>
#<target4xi target = "build2hyperlink4auto.py">
#<abstract4xi abstract = "builds hyperlinks for content objects such as autos"/>
#<refer4xi reference = "version4xi.py>
#<note4xi note = "both embeds control attributes and also uses version4xi.py"/>
# -------------------------------------------------------------------------------------------------
#<use4xi usage = "
#
# 1)  go to Studio4Xi in commmand mode
#       > go3studio4fb    <-- Python 3 version of Studio4Xi in Fastblack workstation
#       > go3studio4riika <-- Python 3 version of Studio4Xi in RiikaPC   workstation
#       TIP: you could use the same go2studio4xi-command in all workstations just varying the content! 
#
# 2)  have you autos saved in hard disk or USB-disk
#       O:\temp\auto
#
# 3)  check trace level in this module
#       default: trace2dragon = False
#
# 4)  create local index files
#     4a) O:\temp\auto                                                                        <-- main folder for autos
#       
#     4b) ROOT4XI\STUDIO4XI\Python\3.3\src\version4xi.py                                           <-- edit this program in RiikaPC
#           'base2build4auto':  None,                                                         <-- generate hyperlinks for local hard disk
#           'folder2build4auto':'O://temp//auto//',                                           <-- content with all subfolders
#     4c)  >> build2hyperlink4auto
#     4d)  delete old index2all4fb.html
#     4e)  rename index2xxxxxxxx4yo.html to index2all4fb.html
#
# 5)  repeat step 3 by editing version4xi.py for subfolders
#     5a)  'O://temp//auto//farmari//',
#          'O://temp//auto//henkilo//',
#          'O://temp//auto//muu//',
#          'O://temp//auto//paku//',
#          'O://temp//auto//tila//',
#          'O://temp//auto//vaihtoehto//',
#     5b) delete old HTML file in subfolder first copy pasting its name
#     5d) rename using copy paste the just (!) generated index2xxxxxxxx4yo.html to that of deleted one
# 
# 6)  create main index file file:///O:/temp/auto/index2auto4fb.html (nb: see TIP)
#     6a) set ack2initialize4constant = True 
#     6b) edit menu content in this program (find: ack2initialize4constant)         
#     6c) see geberated menu
#          file:///O:/temp/auto/index2xxxxxxxx4
#     6d) rename menu to index2auto4fb
#     6e) set ack2initialize4constant = False
#
#     TIP: you normally do this only once unless you notice having done some errors!
#
# 7) build more content and then go back to step 4 
# 
# 12) create hyperlinks for web 
#
# 
# 13)  ** skip this step if you rename the files immediatelly when you create index file, which is highly recommended ** 

# 14) test locally HTML-files accessing local autos - at least some of the new ones

# 
# 15) test locally HTML-files to see references to new autos althought they are not yet in the server

# 16) check that there are no autos left from the previous upload and delete if any

#
# 17) copy HTML files ready for FTP upload

#
# 18) copy autos ready for FTP upload

#
# 19) test upload before FTP

#
# 20) check server hard disk usage and use FTP to delete extra ones
#
# 21) FTP upload
#
# 22) check again server hard disk usage and use FTP to delete extra ones
#
# 23) web test
#      https://www.yourdragonxi.org/web/temp/auto/index2auto4yo.html
#      TIP: go to step 30, if OK
#
# 24) PC test for web
#
#       TIP: 
#
# 25) Upload analysis
#
#       TIP: 
#
# 26) new FTP upload
#       TIP: 
#
# 27) new tests
#
#       TIP: 
#
# 28) tests with reloading/refreshing browser !
#     
#       TIP: 
#
# 29) update Studio4Xi and take its backups to hard disks and FTP-upload, if necessary, for example due to changes to logic
#       
#       TIP: 
#
# 30) take backups
#        
#       TIP: delete old backups being smart to get rid of extra stuff in backup!
#            remember safe unplug for USB devices!
#            you can copy buy skipping existing folders and files in backups!
#            only one backup per session because of the size!
#
# 31) cleanup for the next round ** be careful, see TIP below **
#
#       TIP: recommended to do the next time you update in case you forget to perform step 30!
#
# 32) design to drop less common sizes in server !
#      
#"  
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'build2hyperlink4auto' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi # one alphabet at a time: 'O://temp//job2autos//server//thumb//a//'
from version4xi import ROOT4XI   
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import time4xi
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global count2ack
global count2nack
global count2skipped
global count2found
global count2total

global fileobject

global max2size4ack
global mean2size4ack
global min2size4ack
global sum2size4ack

global kb2fetch                              # knowledgebase for fetching
global max2size4file                         # maximum file size
global path2read4xi                          # path for input source targets

global PickleKB4Xi
global profile2fetch                         # extension for files
global keys2profile

global t2xi 
global trace_object_count
global trace2dragon

global kb2extension                          
global kb2alpha
global kb2dir
global kb2file

#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
count2ack     = 0
count2found   = 0
count2nack    = 0
count2skipped = 0
count2total   = 0

max2size4ack  = 0
mean2size4ack = 0
min2size4ack  = 0
sum2size4ack  = 0                                                                                          

max2size4file = 33000000                            # any (all)   33000000
                                                    # raw          8000000                       
                                                    # large         800000 
                                                    # medium        330000 
                                                    # small setting 210000
                                                    # thumb setting 210000, average measured was 38318
                                                    # ipod          210000    
min2size4ack  = max2size4file

dimension2expect4image = {}
dimension2store4stats  = {}
 
path2read4xi  = VersionKB4Xi['folder2build4auto']    # defines input folder to be walked with all its subfolders
base2build4xi = VersionKB4Xi['base2build4auto']      # base internet address, None=local url is being used

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

trace2dragon = False                                    # False = do NOT produce dragonized trace        
                                                        # True  = create dragonized trace 
                                                        #         sense-build2hyperlink4auto.xml
                                                        #         reason-build2hyperlink4auto.xml
                                                        #         ace-build2hyperlink4auto.xml 
#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "
profile2fetch = {}
profile2fetch [1] = '.html'                             # object types to be accepted for hyperlinks
keys2profile = profile2fetch.keys()
#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    if trace2dragon is True:
        print("(Step 0A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
        print("(Step 0B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        if trace2dragon is True:
            print('=' *33)
            print("STARTING LETTER : ", key2pickledb)
            print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        if trace2dragon is True:
            print("STARTING DICTIONARY: ", dictionary2pickle)
            print('~' *33) 
                
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            if trace2dragon is True:
                print('~' *33)        
            object2pickle = key2dictionary        
            if trace2dragon is True:
                print("STARTING OBJECT: ", object2pickle)
                print('~' *33)         
                pickle4xi(object2pickle)
                print('~' *33)                  
                print("PICKLED object: ", object2pickle)
                # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                if trace2dragon is True:
                    print("(Step 2A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                    # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        if trace2dragon is True:
            print('~' *33)        
            print("COMPLETED  DICTIONARY: ", dictionary2pickle)
            print('~' *33) 
            
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    if trace2dragon is True:
        print('=' *33)
        print("COMPLETED LETTER : ", key2pickledb)
        print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # 10:43:41 04/30/14 FLE Daylight Time
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000002964278>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        if trace2dragon is True:
            print("(Step 02A/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        if trace2dragon is True:
            print("(Step 02B/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            if trace2dragon is True:
                print("(Step 02C/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
                pickle4xi(object2pickle)        
                print("STEP: PICKLED object: ", object2pickle)
                # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            if trace2dragon is True:
                print("(Step 02D/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            if trace2dragon is True:
                print('~' *33)              
                print("(Step 02Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
                print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        if trace2dragon is True:
            print("(Step 02E/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
            
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    if trace2dragon is True:
        print("(Step 02F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
        # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # 10:43:41 04/30/14 FLE Daylight Time
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    if trace2dragon is True:
        print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         # 'Pipe4Xi': 'NACK4TRACE',
         # 'Queue4Xi': 'NACK4TRACE',         
         # 'Process4Xi': 'NACK4TRACE',
         'build2hyperlink4auto': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        if trace2dragon is True:
            print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
            # Pipe4Xi, Process4Xi, Queue4Xi, build2hyperlink4auto

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 0:43:41 04/30/14 FLE Daylight Time

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
#   print XML trace
#"> 
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "build2hyperlink4auto"
    method2print = "build2hyperlink4auto" 
    if trace2dragon is True:    
        message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-build2hyperlink4auto.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing build2hyperlink4auto.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">build2hyperlink4auto sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-build2hyperlink4auto.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for build2hyperlink4auto.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-build2hyperlink4auto.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4apu.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for build2hyperlink4auto.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of build2hyperlink4auto.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "build2hyperlink4auto" usage = "
#   fetches defined targets from dragon4xi folders
#"> 
# -------------------------------------------------------------------------------------------------
def build2hyperlink4auto(target2explore):
    global count2ack
    global count2nack
    global count2skipped
    global count2found
    global count2total

    global fileobject    
    
    global max2size4ack    
    global mean2size4ack
    global min2size4ack
    global sum2size4ack    
    
    global max2size4file 
    global path2read4xi                          # path for input source targets

    global profile2fetch                         # extension for files
    global keys2profile
    global key2profile
    global t2xi
    global trace_object_count    
    
    class2print  = "build2hyperlink4auto"
    method2print = "build2hyperlink4auto" 
 
    count2found = count2found + 1
    if trace2dragon is True:
        message2print = "{(Step 0A/33) using" + "; t2xi-using-by-build2hyperlink4auto: " + str(t2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <print4xi.Print4Xi object at 0x0000000003715080>
    
        message2print = "{(Step 0B/8) got" + "; target2explore-got-by-build2hyperlink4auto: " + str(target2explore)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # 
    
       
           
    # ---------------------------------------------------------------------------------------------
    # SPLIT TARGET NAME WITH PATH AND EXTENSION TO TWO PIECES
    # ---------------------------------------------------------------------------------------------    
    name2target=os.path.splitext(target2explore)
    
    ack2profile = False
    for key2profile in keys2profile:
        if name2target[1] == profile2fetch[key2profile]:
            index2avoid=str.find(target2explore,'index')
            if index2avoid == -1:                                                              
                ack2profile = True
    
            
    if ack2profile is True:     
        # -----------------------------------------------------------------------------------------
        # (Step 1/33) OF FETCH2DRAGON4XI - TARGET
        # -----------------------------------------------------------------------------------------
        if trace2dragon is True:
            message2print = "{(Step 1A/33) analyzing" + "; target2explore-analyzing-by-build2hyperlink4auto: " + str(target2explore) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)      
            
        
        
        path2input = target2explore
        if trace2dragon is True:
            message2print = "{(Step 1B/33) set" + "; path2input-set-by-build2hyperlink4auto to: " + str(path2input)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            #     
        
        
        # -----------------------------------------------------------------------------------------
        # (Step 3/33) OF FETCH2DRAGON4XI - CHECK FILE STATUS
        # -----------------------------------------------------------------------------------------
        status2file = os.stat(path2input)
        if trace2dragon is True:
            message2print = "{(Step 3A/33) got" + "; status2file-got-by-build2hyperlink4auto: " + str(status2file) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # nt.stat_result(st_mode=33206, st_ino=844424930808964, st_dev=0, st_nlink=1, st_uid=0, st_gid=0, st_size=25138, st_atime=1346662717, st_mtime=1346662717, st_ctime=1346662264 

        size2file = status2file.st_size
        if trace2dragon is True: 
            message2print = "{(Step 3B/33) got" + "; size2file-got-by-build2hyperlink4auto: " + str(size2file) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # 25138        
    
        if size2file > max2size4file:
            count2nack = count2nack + 1
            
            message2print = "{(Step 3C1/33) added" + "; count2nack-added-by-build2hyperlink4auto to: " + str(count2nack) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # 1 
            
            message2print = "{(Step 3C2/33) warned" + "; path2input-warned-by-build2hyperlink4auto: " + str(path2input) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # 
            
            message2print = "{(Step 3C3/33) got" + "; size2file-got-by-build2hyperlink4auto: " + str(size2file) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            #               
            
                                    
        else:
            count2ack = count2ack + 1
            if trace2dragon is True:
                message2print = "{(Step 3C3/33) added" + "; count2ack-added-by-build2hyperlink4auto: " + str(count2ack) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                # 1             
            
                       
            sum2size4ack = sum2size4ack + size2file
            
            if size2file > max2size4ack:
                max2size4ack = size2file
            if size2file < min2size4ack:
                min2size4ack = size2file
                           
        count2total = count2total + 1 
        
        # ==========================================================================================================
        # create hyperlink
        # ==========================================================================================================
        try:
            url2web4xi = target2explore
            if trace2dragon is True:
                message2print = "{(Step 4A/33) set" + "; url2web4xi-set-by-build2hyperlink4auto to: " + str(url2web4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 
            
            ack2all4web = False
            string2edit = '\\'
            string2use = '/'
            while 1:
                if ack2all4web is True:
                    break
                else:
                    index2edit=str.find(url2web4xi,string2edit)   
                    if index2edit == -1:
                        ack2all4web = True
                    else:
                        url2web4xi = url2web4xi[0:index2edit] + string2use + url2web4xi[index2edit+1:]
                        if trace2dragon is True:
                            message2print = "{(Step 4B/33) set" + "; url2web4xi-set-by-build2hyperlink4auto to: " + str(url2web4xi) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
            
            name2web=os.path.splitext(url2web4xi)
            if trace2dragon is True:         
                message2print = "{(Step 4C1/33) created" + "; name2web-created-by-build2hyperlink4auto: " + str(name2web[0]) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)     
                # 
            
            shortname2web = name2web[0] 
            string2find = '/'
            ack2all4found = False           
            while 1:
                if ack2all4found is True:
                    break
                else:
                    index2find=str.find(shortname2web,string2find)   
                    if index2find == -1:
                        ack2all4found = True
                    else:
                        shortname2web = shortname2web[index2find+1:]
                        if trace2dragon is True:
                            message2print = "{(Step 4C2/33) set" + "; shortname2web-set-by-build2hyperlink4auto to: " + str(shortname2web) + "; time: " + time4xi() + "}"
                            print4xi(class2print, method2print, message2print)
                            # 
                        
            # =======================================================================================================================
            #
            # =======================================================================================================================                    
            if base2build4xi is None:
                # ===================================================================================================================
                # LOCAL URL
                # ===================================================================================================================
                fileobject.write('<br /><b>&raquo;</b><a href="' + url2web4xi + '" target="_blank">' + shortname2web + '</a>\n')                       
                if trace2dragon is True:
                    message2print = "{(Step 4C3/33) created" + "; shortname2web-created-by-build2hyperlink4auto: " + str(shortname2web) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # 
            else:
                # ===================================================================================================================
                # WEB URL
                # ===================================================================================================================            
                base2localpc = path2read4xi
                if trace2dragon is True:
                    message2print = "{(Step 4C4/33) set" + "; base2localpc-set-by-build2hyperlink4auto to: " + str(base2localpc) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)     
                    # 
                                 
                ack2local4tried = False                   
                while 1:
                    if ack2local4tried is True:
                        break
                    else:
                        index2find=str.find(url2web4xi,base2localpc)            
                        # 
                        #    
                        if index2find == -1:
                            ack2local4tried = True
                        else:
                            # 
                            # 
                            
                            url2web4xi = base2build4xi + url2web4xi[len(base2localpc):]
                            if trace2dragon is True: 
                                message2print = "{(Step 4C5/33) set" + "; url2web4xi-set-by-build2hyperlink4auto to: " + str(url2web4xi) + "; time: " + time4xi() + "}"
                                print4xi(class2print, method2print, message2print)     
                                # 
                            
                            fileobject.write('<br /><b>&raquo;</b><a href="' + url2web4xi + '" target="_blank">' + shortname2web + '</a>\n')
                                                        
                            ack2local4tried = True 
                # ===================================================================================================================
                # BUILD DICTIONARIES
                # =================================================================================================================== 
                # shortname2web = name2web[0]
                # 
                                          
        except:
            message2print = "{(Step 4Z1/33) failed" + "; fileobject-write-failed-by-build2hyperlink4auto: " + str(fileobject) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # 
        
                      
    else:
        if trace2dragon is True:
            message2print = "{(Step 1F/33) skipped" + "; name2target-skipped-by-build2hyperlink4auto: " + str(name2target)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # 
        
        extension2skip = name2target[1]
        if trace2dragon is True:
            message2print = "{(Step 1G/33) skipped" + "; extension-skipped-by-build2hyperlink4auto: " + str(extension2skip[1:])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
            # 
        
        count2skipped = count2skipped + 1
        
                    
#</function4xi>
    

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global count2ack
    global count2nack
    global count2skipped
    global count2found
    global count2total
    
    global fileobject
    
    global max2size4ack    
    global mean2size4ack
    global min2size4ack
    global sum2size4ack    
    
    global sum2size4ack    
        
    global max2size4file 
    global dimension2expect4image
    global dimension2store4stats    
            
    global path2read4xi
    global profile2fetch

    global t2xi
    global trace_object_count    

                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    if trace2dragon is True:
        print("(Step 0A1/33) OF MAIN FETCH2DRAGON4XI - SET T2XI TO: ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000003715080> 
    
     
    count2skipped = 0
    count2found = 0
    count2total  = 0   

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE MULTIPROCESSING MECHANISM JUST IN CASE
    # -------------------------------------------------------------------------------------------------    
    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE OPTIONAL CONSTANT MAIN INDEX HTML
    # -------------------------------------------------------------------------------------------------        
    ack2initialize4constant = False                                                                                 # True to test HTML file creation
    if ack2initialize4constant is True:
        # ==========================================================================================================
        # BUILD STATIC MAIN HTML FILE (remember to define folder2build4auto in version4xi.py right!)
        # ==========================================================================================================    
        path2index4all = None
        try:
            name2index4all = "index2xxxxxxxx4yo.html"                                                                # user to rename output file, for example index2thumb4yo.html
            path2index4all = path2read4xi + name2index4all
            print("(Step 0A12/33) OF MAIN FETCH2DRAGON4XI - SET PATH2INDEX4ALL TO: ", path2index4all)
            # 
        except:
            print("(Step 0A1Z2/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO INITIALIZE PATH2INDEX4ALL: ", path2index4all)         
            #                    
        fileobject = None
        try:
            fileobject = open(path2index4all,'w')
            print("(Step 0A13/33) OF MAIN FETCH2DRAGON4XI - OPENED OUTPUT: ", fileobject)
            # 
        except:
            print("(Step 0A1Z3/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO OPEN OUTPUT: ", fileobject)         
            # 
        try:                
            fileobject.write('<html>\n')
            
            fileobject.write('<style type="text/css" media="all">\n')
            fileobject.write(' @import "https://www.yourdragonxi.org/css/halongbay.css";\n')
            fileobject.write('</style> \n')
            fileobject.write('<p>\n')
            fileobject.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject.write('<br /><a id="000">yourdragon<b>&Xi;</b> @Content</a>\n')
            fileobject.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject.write('<br /> \n')
            fileobject.write('<br /><b>&raquo;</b><a href="farmari/index2farmari4fb.html" target="_blank">Farmari</a>\n')
            fileobject.write('<br /><b>&raquo;</b><a href="henkilo/index2henkilo4fb.html" target="_blank">Henkilo</a>\n')
            fileobject.write('<br /><b>&raquo;</b><a href="muu/index2muu4fb.html" target="_blank">Muu</a>\n')
            fileobject.write('<br /><b>&raquo;</b><a href="paku/index2paku4fb.html" target="_blank">Paku</a>\n')
            fileobject.write('<br /><b>&raquo;</b><a href="tila/index2tila4fb.html" target="_blank">Tila</a>\n')
            fileobject.write('<br /><b>&raquo;</b><a href="vaihtoehto/index2vaihtoehto4fb.html" target="_blank">Vaihtoehto</a>\n')
            fileobject.write('<br /><b>&raquo;</b><a href="index2all4fb.html" target="_blank">Kaikki</a>\n')
            fileobject.write('<br /> \n')
            fileobject.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
            fileobject.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
            fileobject.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
            fileobject.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
            fileobject.write('</p>\n')
            # 
            fileobject.write('</html>\n')
        except:
            print("(Step 0A1Z4/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO WRITE TO OUTPUT: ", fileobject)         
            #            
        try:    
            fileobject.close()
            print("(Step 0A15/33) OF MAIN FETCH2DRAGON4XI - CLOSED OUTPUT: ", fileobject)         
            #         
        except:
            print("(Step 0A1Z5/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO CLOSE OUTPUT: ", fileobject)         
            #    
    else:
        # ==========================================================================================================
        # DYNAMICALLY BUILD HTML FILE USING SUBDIRECTORIES
        # ==========================================================================================================
        path2index4all = None
        try:
            name2index4all = "index2xxxxxxxx4yo.html"
            path2index4all = path2read4xi + name2index4all
            print("(Step 1A/33) OF MAIN FETCH2DRAGON4XI - SET PATH2INDEX4ALL TO: ", path2index4all) 
            # O://temp//auto//vaihtoehto//index2xxxxxxxx4yo.html
        except:
            print("(Step 1Z/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO INITIALIZE PATH2INDEX4ALL: ", path2index4all)         
            #                    
        fileobject = None
        try:
            fileobject = open(path2index4all,'w')
            print("(Step 2A/33) OF MAIN FETCH2DRAGON4XI - OPENED OUTPUT: ", fileobject)
            # <_io.TextIOWrapper name='O://temp//auto//vaihtoehto//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>
        except:
            print("(Step 2Z1/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO OPEN OUTPUT: ", fileobject)         
            # 
        try:                
            fileobject.write('<html>\n')
            
            fileobject.write('<style type="text/css" media="all">\n')
            fileobject.write(' @import "https://www.yourdragonxi.org/css/halongbay.css";\n')
            fileobject.write('</style> \n')
            fileobject.write('<p>\n')
            fileobject.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject.write('<br /><a id="000">yourdragon<b>&Xi;</b> @Content</a>\n')
            fileobject.write('<br /><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b><b>&Xi;</b>\n')
            fileobject.write('<br /> \n')

        except:
            print("(Step 2Z2/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO WRITE TO OUTPUT: ", fileobject)         
            #            

        
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 4A/33) OF MAIN FETCH2DRAGON4XI - VERSION 9.17.12.17 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " STARTED ", time4xi())
    # VERSION 9.17.12.17 FOR  O://temp//auto//vaihtoehto//  WITH PROFILE:  {1: '.html'}  STARTED  10:43:41 04/30/14 FLE Daylight Time
    
    print('=' *70)    
   
    pipe2fetch = Pipe4Xi()
    print("(Step 4B/33) OF MAIN FETCH2DRAGON4XI - PIPE2FETCH ", pipe2fetch)    
    # (<pipeconnection4xi.PipeConnection4Xi object at 0x0000000003365DD8>, <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003365E10>)
    
    queue2fetch = Queue4Xi()
    print("(Step 4C/33) OF MAIN FETCH2DRAGON4XI - QUEUE2FETCH ", queue2fetch)    
    # <queue4xi.Queue4Xi object at 0x0000000003319E48>
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            pass
            # print ("Directory: " + file2walk + '\n')
            # 
        if os.path.isfile(file2walk):
            # print("Input file: ", file2walk)
            build2hyperlink4auto(file2walk)
            
                        
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    try:
        fileobject.write('<br /> \n')
        fileobject.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
        fileobject.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br />\n')
        fileobject.write('<br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /><br /> \n')
        fileobject.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
        fileobject.write('<br />Small & Smart Inc reserves rights to change this document without any notice\n')
        fileobject.write('<br />~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n')
        fileobject.write('</p>\n')
        # 
        fileobject.write('</html>\n')
    except:
        print("(Step 5Z1/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO WRITE TO OUTPUT: ", fileobject)         
        #            
    try:    
        fileobject.close()
        print("(Step 5Z2/33) OF MAIN FETCH2DRAGON4XI - CLOSED OUTPUT: ", fileobject)         
        # <_io.TextIOWrapper name='O://temp//auto//vaihtoehto//index2xxxxxxxx4yo.html' mode='w' encoding='cp1252'>       
    except:
        print("(Step 5Z2/33) OF MAIN FETCH2DRAGON4XI *** FAILED TO CLOSE OUTPUT: ", fileobject)         
        #    
    
    print('=' *75)
    print("(Step 8A/33) OF MAIN FETCH2DRAGON4XI - STATISTICS OF VERSION 9.17.12.18 FOR ", path2read4xi, " WITH PROFILE: ", profile2fetch, " COMPLETED  ", time4xi())
    # STATISTICS OF VERSION 9.17.12.18 FOR  O://temp//auto//vaihtoehto//  WITH PROFILE:  {1: '.html'}  COMPLETED   10:43:41 04/30/14 FLE Daylight Time
            
    # -------------------------------------------------------------------------------------------
    # STATISTICS
    # ------------------------------------------------------------------------------------------- 
    print ('(Step 8B/33) OF MAIN FETCH2DRAGON4XI - FILES FOUND: ', count2found)
    print ('(Step 8C/33) OF MAIN FETCH2DRAGON4XI - ACKNOWLEDGED: ', count2ack, ' MAX2SIZE4FILE: ', max2size4file)
    if count2nack > 0:
        print ('(Step 8D/33) OF MAIN FETCH2DRAGON4XI - ** WARNED ** ', count2nack)
    else:
        print ('(Step 8E/33) OF MAIN FETCH2DRAGON4XI - ALL ACCEPTED')
    print ('(Step 8F/33) OF MAIN FETCH2DRAGON4XI - SKIPPED: ', count2skipped)
    print ('(Step 8J/33) OF MAIN FETCH2DRAGON4XI - TOTAL: ', count2total)
    if count2ack > 0:
        mean2size4ack = int(sum2size4ack / count2ack)
    else:
        mean2size4ack = 0    
    print ('(Step 8K/33) OF MAIN FETCH2DRAGON4XI - MEAN4ACK: ', mean2size4ack)
    print ('(Step 8L/33) OF MAIN FETCH2DRAGON4XI - MAX4ACK: ', max2size4ack)
    if count2ack == 0:
        min2size4ack = 0
    print ('(Step 8M/33) OF MAIN FETCH2DRAGON4XI - MIN4ACK: ', min2size4ack)
    test2total = count2ack + count2nack + count2skipped
    if test2total == count2found:
        pass
    else:
        print ('(Step 8Z1/33) OF MAIN FETCH2DRAGON4XI *** FAILED: FOUND + SKIPPED: ', test2total, " .NE. FOUND: ", count2found, " ***")
    
    # ===========================================================================
    # (Step 8B/33) OF MAIN FETCH2DRAGON4XI - FILES FOUND:  2
    # ACKNOWLEDGED:  0  MAX2SIZE4FILE:  33000000
    # ALL ACCEPTED
    # SKIPPED:  2
    # TOTAL:  0
    # MEAN4ACK:  0
    # MAX4ACK:  0
    # MIN4ACK:  0
    # ===========================================================================         
    print('=' *75)

    # ====================================

        
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print ('(Step 0J/33) OF MAIN FETCH2DRAGON4XI - PRINTING TRACE WITH T2XI', t2xi)
    # <print4xi.Print4Xi object at 0x0000000002964278>
    print_trace4xi(t2xi)        
    print ('(Step 0K/33) OF MAIN FETCH2DRAGON4XI - PRINTED TRACE WITH T2XI', t2xi)           
    #     
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</target4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# 
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of build2hyperlink4auto.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

